#!/usr/bin/perl

# GNUSearch
# 2000 Hector Facundo Arena
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.                                       
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.                               
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


require "config.pl";

$url="http://www.myurl.com";
$title="Web Page Title";
$description="This is my homepage. Thank you for coming!";
$allok=0;

$query=<STDIN>;
@temp_array=split(/&/,$query);		# Save the query in a temporal array

foreach(@temp_array) {                  # clean up the garbage ;)
    tr/+/ /;
    s/=/ /;
    s/%(..)/pack("C",hex($1))/ge;
    }


$url=$temp_array[2];
$url=substr($url,4,200);                  # Clean URL data

$title=$temp_array[0];
$title=substr($title,6,200);		# Clean Title data

$description=$temp_array[1];
$description=substr($description,12,200);	# Clean description data

print "Content-type: text/html\n\n";
print "<HTML>\n";
print "<HEAD><TITLE> Thanks for adding your site to $site_name! </TITLE></HEAD>\n";
print "<BODY bgcolor=ffffff>\n";

open(linksbase, "filebase.txt");  	# Open the links database

# First Test: We already have that link?

while(<linksbase>) {
@fullsearch=split(/&/,$_);


foreach(@fullsearch) {                  # clean up the garbage ;)
    tr/+/ /;
    s/=/ /;
    s/%(..)/pack("C",hex($1))/ge;
    }

$temp_url=$fullsearch[0];

if($url eq $temp_url) {
    print "<center><h4> That URL is already on our database. Anyway, Thanks!</h4></center>\n";
    print "<center><a href=$site_url>Go back to $site_name!</a>\n";
    print "<p align=right <h6>This site runs under <a href=http://cnhtech.com/~hfa> GNUSearch</a>.2000 Hector Facundo Arena</h6></p>\n";
    print "</body>";
    print "\n</html>";
    $allok=1;
    close;
    } 
}
close linksbase;

# Second Test: Submitting null information

if(($url eq "") || ($title eq "") || ($description eq ""))
{
    print "<center><h4> Please, fill in all the form data!</h4></center>\n";
    print "<center><a href=$site_url>Go back to $site_name!</a>\n";
    print "<p align=right <h6>This site runs under <a href=http://cnhtech.com/~hfa>GNUSearch</a>.2000 Hector Facundo Arena</h6></p>\n";
    print "</body>";
    print "\n</html>";
    $allok=1;
    close;
}

# Third test: not allowed urls
open (garbage,"words.txt");
while(<garbage>) {
    if(($_ =~ /$url/i) || ($_ =~ /$title/i) || ($_ =~ /$description/i))
	{
        print "<center><h4> We do not allow that kind of sites.</h4></center>\n";
        print "<center><a href=$site_url>Go back to $site_name!</a>\n";
        print "<p align=right <h6>This site runs under <a href=http://cnhtech.com/~hfa>GNUSearch</a>.2000 Hector Facundo Arena</h6></p>\n";
        print "</body>";
        print "\n</html>";
	$allok=1;
	close;
    }
}
close garbage;


if($allok eq 0) {
open(linksbase, ">>filebase.txt");  	# Open the links database in append mode

print linksbase "$url";
print linksbase "&$title";
print linksbase "&$description\n";

####### Send an email to the administrator ##########

if($info_add eq "yes") {
    send_mail();
}

####### Print a 'thanks' message ########

print "<center><h1>$site_name</h1></center>\n";
print "<center><h4>Thanks for adding your site to $site_name!</h4>\n";
print "<normal>Your site is now on the $site_name database.</normal></center>\n";
print "<center><a href=$site_url>Go back to $site_name!</a>\n";
print "<p align=right <h6>This site runs under <a href=http://cnhtech.com/~hfa>GNUSearch</a>.2000 Hector Facundo Arena</h6></p>\n";
print "</body>";
print "\n</html>";
close linksbase;
}

close;


### send_mail() sends an email to the administrator of the site every time a 
### new link is added.

sub send_mail() {
$url =~ tr/+/ /;
$url =~ s/=/ /;
$url =~ s/%(..)/pack("C",hex($1))/ge;
$title =~ tr/+/ /;
$title =~ s/=/ /;
$title =~ s/%(..)/pack("C",hex($1))/ge;
open (mailfile,">mail.txt");
print mailfile "GNUSearch\n";
print mailfile "\n";
print mailfile "Hi LinksAdmin!\n";
print mailfile "Someone's have added a link to your links database.\n";
print mailfile "This message is automatically generated. If you dont\n";
print mailfile "want to receive this kind of mails, you can set to 'no'\n";
print mailfile "the 'info_add' variable on config.pl.\n\n";
print mailfile "URL: $url\n";
print mailfile "TITLE: $title\n";
print mailfile "\n\nBest regards,\n\n";
print mailfile "Your Server";
close mailfile; 
open (MAILER, "|mail -s $site_name $admin_mail<mail.txt");
close MAILER;
}