#!/usr/bin/perl

# GNUSearch
# 2000 Hector Facundo Arena
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


require "config.pl";

$query=<STDIN>;

$url="No Url";
$title="No title";
$description="No description";
$thequery="no query";

$counter=0;

$query=substr($query,6,200);
$query =~ tr/+/&/;
@query_search=split(/&/,$query);

#############################
# Print the HTML Header     #
#############################

print "Content-type: text/html\n\n";
print "<HTML>\n";
print "<HEAD><TITLE>$site_name - Search results for: '@query_search' </title></head>\n";
print "<body bgcolor=$background>\n";
print "<center><h2>[$site_name]: Search results for '@query_search'</h2></center>\n";

# Ok now start searching the database. #

foreach $thequery (@query_search) {
open(database, "filebase.txt");		# Open the database
while(<database>) {
@fullsearch=split(/&/,$_);	 	# make the query array

foreach(@fullsearch) {			# clean up the garbage ;)
    tr/+/ /;
    s/=/ /;
    s/%(..)/pack("C",hex($1))/ge;
    }

$url=$fullsearch[0];
$title=$fullsearch[1];
$description=$fullsearch[2];

##########################################################################
# Comparation stage: Local database                                      #
##########################################################################

if(("$title" =~ /$thequery/i) ||  ($thequery =~ /$url/i) || ("$description" =~ /$thequery/i)) {
 $counter++;
    if($counter eq $max_results) {
    print"<center><h4>Too many results! Try using less keywords</h4></center>\n";
    }
print "Match #$counter: <a href=$url>$title</a>";
print "$description";
 }
}
    if ($counter eq 0) {
     print "<center><H4>No sites found in the database. Try Another search!</h4></center>\n";
    }
close database;
}


print "<center><a href=$site_url>[Go back to $site_name!]</a>\n";
print "<p align=right <normal>This site runs under <a href=http://cnhtech.com/~hfa>GNUSearch </a>.Copyright 2000 Hector Facundo Arena.</p></normal>\n";
print "</body>";
print "\n</html>";
close;

